"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = createContext;

var _time = _interopRequireDefault(require("./time"));

var _ = _interopRequireWildcard(require("./lodash"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function createContext(configuration) {
  if (_.isUndefined(configuration) || _.isUndefined(configuration.context)) {
    throw new Error('Unable to create context, the given configuration is not valid');
  }

  var inputContext = _.omit(configuration.context, configuration.output);

  for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    args[_key - 1] = arguments[_key];
  }

  return _.reduce(args, function (context, arg) {
    if (arg instanceof _time["default"]) {
      var day_of_month = arg.day_of_month,
          day_of_week = arg.day_of_week,
          month_of_year = arg.month_of_year,
          time_of_day = arg.time_of_day,
          timezone = arg.timezone;
      return _.mapValues(inputContext, function (v, k) {
        if (v.type === 'day_of_week' && (_.isUndefined(v.is_generated) || v.is_generated)) {
          return day_of_week;
        } else if (v.type === 'time_of_day' && (_.isUndefined(v.is_generated) || v.is_generated)) {
          return time_of_day;
        } else if (v.type === 'day_of_month' && (_.isUndefined(v.is_generated) || v.is_generated)) {
          return day_of_month;
        } else if (v.type === 'month_of_year' && (_.isUndefined(v.is_generated) || v.is_generated)) {
          return month_of_year;
        } else if (v.type === 'timezone') {
          return timezone;
        } else {
          return context[k];
        }
      });
    } else {
      return _.mapValues(inputContext, function (v, k) {
        return _.isUndefined(arg[k]) ? context[k] : arg[k];
      });
    }
  }, _.mapValues(inputContext, function () {
    return undefined;
  }));
}