"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = parse;

var _errors = require("./errors");

var _semver = _interopRequireDefault(require("semver"));

var _ = _interopRequireWildcard(require("./lodash"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function parse(input) {
  var json = _.isObject(input) ? input : JSON.parse(input);

  if (!_.isObject(json) || _.isArray(input)) {
    throw new _errors.CraftAiDecisionError('Invalid decision tree format, the given json is not an object.');
  }

  if (_.isUndefined(json) || _.isUndefined(json._version)) {
    throw new _errors.CraftAiDecisionError('Invalid decision tree format, unable to find the version informations.');
  }

  var version = json._version;

  if (!_semver["default"].valid(version)) {
    throw new _errors.CraftAiDecisionError("Invalid decision tree format, \"".concat(version, "\" is not a valid version."));
  } else if (_semver["default"].satisfies(version, '>=1.0.0 <3.0.0')) {
    return json;
  } else {
    throw new _errors.CraftAiDecisionError("Invalid decision tree format, \"".concat(version, "\" is not a supported version."));
  }
}