"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.reduceDecisionRules = reduceDecisionRules;

var _formatter = require("./formatter");

var _constants = require("./constants");

var _ = _interopRequireWildcard(require("./lodash"));

var _OPERATORS$IN, _OPERATORS$GTE, _OPERATORS$LT, _REDUCER_FROM_DECISIO;

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var REDUCER_FROM_DECISION_RULE = (_REDUCER_FROM_DECISIO = {}, _defineProperty(_REDUCER_FROM_DECISIO, _constants.OPERATORS.IS, _defineProperty({}, _constants.OPERATORS.IS, function (decisionRule1, decisionRule2) {
  if (decisionRule1.operand && decisionRule1.operand != decisionRule2.operand) {
    throw new Error("Operator \"".concat(_constants.OPERATORS.IS, "\" can't have different value. Set to \"").concat(decisionRule1.operand, "\" and receive \"").concat(decisionRule2.operand, "\""));
  }

  return {
    property: decisionRule1.property,
    operator: _constants.OPERATORS.IS,
    operand: decisionRule2.operand
  };
})), _defineProperty(_REDUCER_FROM_DECISIO, _constants.OPERATORS.IN, (_OPERATORS$IN = {}, _defineProperty(_OPERATORS$IN, _constants.OPERATORS.IN, function (decisionRule1, decisionRule2) {
  var _decisionRule1$operan = _slicedToArray(decisionRule1.operand, 2),
      o1From = _decisionRule1$operan[0],
      o1To = _decisionRule1$operan[1];

  var _decisionRule2$operan = _slicedToArray(decisionRule2.operand, 2),
      o2From = _decisionRule2$operan[0],
      o2To = _decisionRule2$operan[1];

  var o1IsCyclic = o1From > o1To;
  var o2IsCyclic = o2From > o2To;
  var o2FromInO1 = o1IsCyclic ? o2From >= o1From || o2From <= o1To : o2From >= o1From && o2From <= o1To;
  var o2ToInO1 = o1IsCyclic ? o2To >= o1From || o2To <= o1To : o2To >= o1From && o2To <= o1To;
  var o1FromInO2 = o2IsCyclic ? o1From >= o2From || o1From <= o2To : o1From >= o2From && o1From <= o2To;
  var o1ToInO2 = o2IsCyclic ? o1To >= o2From || o1To <= o2To : o1To >= o2From && o1To <= o2To;

  if (o1FromInO2 && o1ToInO2) {
    // o1 belongs to o2
    //    |    o1    |
    //   |       o2       |
    return decisionRule1;
  }

  if (o2FromInO1 && o2ToInO1) {
    // o2 belongs to o1
    //    |    o1    |
    //      |  o2  |
    return decisionRule2;
  }

  if (o2FromInO1 && o1ToInO2) {
    // overlap 1
    //    |    o1    |
    //             |   o2   |
    return {
      property: decisionRule1.property,
      operator: _constants.OPERATORS.IN,
      operand: [o2From, o1To]
    };
  }

  if (o2ToInO1 && o1FromInO2) {
    // overlap 2
    //        |    o1    |
    //     |   o2   |
    return {
      property: decisionRule1.property,
      operator: _constants.OPERATORS.IN,
      operand: [o1From, o2To]
    };
  } // disjointed
  //    |    o1    |
  //                  |   o2   |


  throw new Error("Unable to reduce decision rules '".concat((0, _formatter.formatDecisionRules)([decisionRule1]), "' and '").concat((0, _formatter.formatDecisionRules)([decisionRule2]), "': the resulting rule is not fulfillable."));
}), _defineProperty(_OPERATORS$IN, _constants.OPERATORS.GTE, function (decisionRule1, decisionRule2) {
  var _decisionRule1$operan2 = _slicedToArray(decisionRule1.operand, 2),
      o1From = _decisionRule1$operan2[0],
      o1To = _decisionRule1$operan2[1];

  var o2 = decisionRule2.operand;
  var o1IsCyclic = o1From > o1To;

  if (o1IsCyclic) {
    // Cyclics makes no sense with single bound limits
    throw new Error("Unable to reduce decision rules '".concat((0, _formatter.formatDecisionRules)([decisionRule1]), "' and '").concat((0, _formatter.formatDecisionRules)([decisionRule2]), "': the resulting rule is not fulfillable."));
  }

  if (o2 >= o1To) {
    // o2 after o1, disjointed
    //    |    o1    |
    //                  |o2
    throw new Error("Unable to reduce decision rules '".concat((0, _formatter.formatDecisionRules)([decisionRule1]), "' and '").concat((0, _formatter.formatDecisionRules)([decisionRule2]), "': the resulting rule is not fulfillable."));
  }

  if (o2 >= o1From && o2 < o1To) {
    // o2 belongs to o1
    //    |    o1    |
    //           |o2
    return {
      property: decisionRule1.property,
      operator: _constants.OPERATORS.IN,
      operand: [o2, o1To]
    };
  } // o2 before o1
  //    |    o1    |
  //   |o2


  return decisionRule1;
}), _defineProperty(_OPERATORS$IN, _constants.OPERATORS.LT, function (decisionRule1, decisionRule2) {
  var _decisionRule1$operan3 = _slicedToArray(decisionRule1.operand, 2),
      o1From = _decisionRule1$operan3[0],
      o1To = _decisionRule1$operan3[1];

  var o2 = decisionRule2.operand;
  var o1IsCyclic = o1From > o1To;

  if (o1IsCyclic) {
    // Cyclics makes no sense with single bound limits
    throw new Error("Unable to reduce decision rules '".concat((0, _formatter.formatDecisionRules)([decisionRule1]), "' and '").concat((0, _formatter.formatDecisionRules)([decisionRule2]), "': the resulting rule is not fulfillable."));
  }

  if (o2 < o1From) {
    // o2 before o1, disjointed
    //      |    o1    |
    // o2|
    throw new Error("Unable to reduce decision rules '".concat((0, _formatter.formatDecisionRules)([decisionRule1]), "' and '").concat((0, _formatter.formatDecisionRules)([decisionRule2]), "': the resulting rule is not fulfillable."));
  }

  if (o2 >= o1From && o2 < o1To) {
    // o2 belongs to o1
    //    |    o1    |
    //         o2|
    return {
      property: decisionRule1.property,
      operator: _constants.OPERATORS.IN,
      operand: [o1From, o2]
    };
  } // o2 after o1
  //    |    o1    |
  //                 o2|


  return decisionRule1;
}), _OPERATORS$IN)), _defineProperty(_REDUCER_FROM_DECISIO, _constants.OPERATORS.GTE, (_OPERATORS$GTE = {}, _defineProperty(_OPERATORS$GTE, _constants.OPERATORS.IN, function (decisionRule1, decisionRule2) {
  return REDUCER_FROM_DECISION_RULE[_constants.OPERATORS.IN][_constants.OPERATORS.GTE](decisionRule2, decisionRule1);
}), _defineProperty(_OPERATORS$GTE, _constants.OPERATORS.GTE, function (decisionRule1, decisionRule2) {
  return {
    property: decisionRule1.property,
    operator: _constants.OPERATORS.GTE,
    operand: Math.max(decisionRule1.operand, decisionRule2.operand)
  };
}), _defineProperty(_OPERATORS$GTE, _constants.OPERATORS.LT, function (decisionRule1, decisionRule2) {
  var newLowerBound = decisionRule1.operand;
  var newUpperBound = decisionRule2.operand;

  if (newUpperBound < newLowerBound) {
    throw new Error("Unable to reduce decision rules '".concat((0, _formatter.formatDecisionRules)([decisionRule1]), "' and '").concat((0, _formatter.formatDecisionRules)([decisionRule2]), "': the resulting rule is not fulfillable."));
  }

  return {
    property: decisionRule1.property,
    operator: _constants.OPERATORS.IN,
    operand: [newLowerBound, newUpperBound]
  };
}), _OPERATORS$GTE)), _defineProperty(_REDUCER_FROM_DECISIO, _constants.OPERATORS.LT, (_OPERATORS$LT = {}, _defineProperty(_OPERATORS$LT, _constants.OPERATORS.IN, function (decisionRule1, decisionRule2) {
  return REDUCER_FROM_DECISION_RULE[_constants.OPERATORS.IN][_constants.OPERATORS.LT](decisionRule2, decisionRule1);
}), _defineProperty(_OPERATORS$LT, _constants.OPERATORS.GTE, function (decisionRule1, decisionRule2) {
  return REDUCER_FROM_DECISION_RULE[_constants.OPERATORS.GTE][_constants.OPERATORS.LT](decisionRule2, decisionRule1);
}), _defineProperty(_OPERATORS$LT, _constants.OPERATORS.LT, function (decisionRule1, decisionRule2) {
  return {
    property: decisionRule1.property,
    operator: _constants.OPERATORS.LT,
    operand: Math.min(decisionRule1.operand, decisionRule2.operand)
  };
}), _OPERATORS$LT)), _REDUCER_FROM_DECISIO);

function decisionRuleReducer(decisionRule1, decisionRule2) {
  if (!decisionRule1 || !decisionRule2) {
    return decisionRule1 || decisionRule2;
  }

  var reducer = REDUCER_FROM_DECISION_RULE[decisionRule1.operator][decisionRule2.operator];

  if (!reducer) {
    throw new Error("Unable to reduce decision rules '".concat((0, _formatter.formatDecisionRules)([decisionRule1]), "' and '").concat((0, _formatter.formatDecisionRules)([decisionRule2]), "': incompatible operators."));
  }

  return reducer(decisionRule1, decisionRule2);
}

function reduceDecisionRules(decisionRules) {
  var properties = _.uniq(_.map(decisionRules, function (_ref) {
    var property = _ref.property;
    return property;
  }));

  return _.map(properties, function (currentPropery) {
    return decisionRules.filter(function (_ref2) {
      var property = _ref2.property;
      return property == currentPropery;
    }).reduce(decisionRuleReducer, undefined);
  });
}