"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getTimezoneKey = getTimezoneKey;
exports["default"] = exports.timezones = void 0;

var _ = _interopRequireWildcard(require("./lodash"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var TIMEZONE_REGEX = /^([+-](2[0-3]|[01][0-9])(:?[0-5][0-9])?|Z)$/; // +/-00:00 -/+00 Z +/-0000

var timezones = {
  'UTC': '+00:00',
  'GMT': '+00:00',
  'BST': '+01:00',
  'IST': '+01:00',
  'WET': '+00:00',
  'WEST': '+01:00',
  'CET': '+01:00',
  'CEST': '+02:00',
  'EET': '+02:00',
  'EEST': '+03:00',
  'MSK': '+03:00',
  'MSD': '+04:00',
  'AST': '-04:00',
  'ADT': '-03:00',
  'EST': '-05:00',
  'EDT': '-04:00',
  'CST': '-06:00',
  'CDT': '-05:00',
  'MST': '-07:00',
  'MDT': '-06:00',
  'PST': '-08:00',
  'PDT': '-07:00',
  'HST': '-10:00',
  'AKST': '-09:00',
  'AKDT': '-08:00',
  'AEST': '+10:00',
  'AEDT': '+11:00',
  'ACST': '+09:30',
  'ACDT': '+10:30',
  'AWST': '+08:00'
};
exports.timezones = timezones;

var isTimezone = function isTimezone(value) {
  return _.isInteger(value) ? value <= 840 && value >= -720 : _.isString(value) && (value in timezones || TIMEZONE_REGEX.test(value));
};

function getTimezoneKey(configuration) {
  return _.findKey(configuration, {
    'type': 'timezone'
  });
}

var _default = isTimezone;
exports["default"] = _default;